% Dmonstration des caractristiques des diffrents types de priodogramme
%
%    Copyright (C) 2008-2014  Yves Goussard
%
%    This program is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see <http://www.gnu.org/licenses/>.

clear

N = 1024;
Wn = .3;
ordre = 2;
TypeP = {'Simple'; 'Moyenn'; 'Liss'}; % Types de priodogrammes

[B, A] = butter(ordre, Wn);

RF = abs(fftshift(fft(B, N) ./ fft(A, N)));
nu = fftshift((0:N-1)/N);
nu(find(nu > 1/2)) = nu(find(nu > 1/2)) - 1;

figure(1)
set(gcf, 'WindowStyle', 'Docked')

semilogy(nu, RF.^2), grid
set(gca, 'Ylim', [1e-04, 1e+01])
title('SPECTRE EXACT DU SIGNAL', 'Fontsize', 14)
xlabel('Frquences rduites', 'Fontsize', 12)


% Gnration du bruit

Lsig = 6;
Lbl = Lsig;
ITypeP = 1;

Titre = 'Calcul de priodogrammes';
Item4 = 'Calculer le priodogramme';
Item5 = 'Quitter';
TODO = 0;

while TODO ~= 5
    
    Item1 = ['Priodogramme ', lower(TypeP{ITypeP})];
    Item2 = sprintf('Longueur du signal : %1.0f (2^%1.0f)', 2^Lsig, Lsig);
    Item3 = sprintf('Longueur de la fentre : %1.0f (2^%1.0f)', 2^Lbl, Lbl);

    TODO = menu(Titre, Item1, Item2, Item3, Item4, Item5);
    
    switch TODO
        
        case 1
            ITypeP = menu('Type du priodogramme', TypeP{1}, TypeP{2}, TypeP{3});
        
        case 2
            Lsig_n = ...
                input(sprintf(['Longueur du signal en puissance de 2 ', ...
                '[Dfaut 2^%1.0f = %1.0f] : '], Lsig, 2^Lsig));
            
            if ~ isempty(Lsig_n)
                Lsig = Lsig_n;
            end
            
        case 3
            Lbl_n = ...
                input(sprintf(['Longueur de la fentre en puissance de 2 ', ...
                '[Dfaut 2^%1.0f = %1.0f] : '], Lbl, 2^Lbl));
            
            if ~ isempty(Lbl_n)
                Lbl = Lbl_n;
            end
            
        case 4
                        
            randn('seed', 0);
            u = randn(2^Lsig, 1);

            x = filter(B, A, u);

            figure(1), clf

            plot(1:2^Lsig, x), grid
            xlabel('Nombre d''chantillons', 'Fontsize', 12)
            ylabel('Amplitude', 'Fontsize', 12)
            title('SIGNAL  ANYALSER', 'Fontsize', 14)
            
            
            if ITypeP == 3
                
                x_l = hankel(x(1:2^Lbl), x(2^Lbl:2^Lsig)');
                Hamm = hamming(2^Lbl);
                Hamm = Hamm / sqrt(sum(Hamm.^2) / 2^Lbl);
                Nbl = size(x_l, 2);

                X = fft(x_l .* Hamm(:, ones(1, Nbl)));
                Per_X = sum(X .* conj(X), 2)/ (2^Lbl * Nbl);
                titre = upper(sprintf(['PRIODOGRAMME ', TypeP{ITypeP},...
                    ', FENTRE DE TAILLE %1.0f'], 2^Lbl));
                
            else
                
                if (ITypeP == 1) & (Lbl ~= Lsig)
                    disp('Attention : longueur de fentre mise  la taille du signal')
                    Lbl = Lsig;
                end
                
                Nbl = Lsig - Lbl;
                X = fft(reshape(x, 2^Lbl, 2^Nbl));
                Per_X = sum(X .* conj(X), 2)/ 2^Lsig;
                titre = upper(sprintf(['PRIODOGRAMME ', TypeP{ITypeP},...
                    ', %1.0f FENTRE(S) DE TAILLE %1.0f'], 2^Nbl, 2^Lbl));

                
            end
            
            nu_X = -1/2:2^-Lbl:(1/2-2^-Lbl);

            figure(2), clf
            set(gcf, 'WindowStyle', 'Docked')

            semilogy(nu_X, fftshift(Per_X)), hold on
            semilogy(nu, RF.^2, 'r'), hold off, grid
            xlabel('Frquences rduites', 'Fontsize', 12)
            title(titre, 'Fontsize', 14)
      

            set(gca, 'Ylim', [1e-04, 1e+01])
            
    end
    
end

